\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{progiexs} [2004/02/23 v4.1 Classe Progiexs]
\DeclareOption{files}{\let\nofiles\relax}
\DeclareOption*{\PassOptionsToClass{\CurrentOption}{article}}
\ProcessOptions
\PassOptionsToClass{leqno,a4paper}{article}
\LoadClass{article}
%
\setlength{\hoffset}{-1in}
\setlength{\voffset}{-12mm}
\setlength{\textheight}{220mm}
\setlength{\textwidth}{155mm}
\setlength{\parskip}{1mm}
%
\nofiles
%
\RequirePackage[catalan]{babel}
\RequirePackage[latin1]{inputenc}
\RequirePackage{alseda,alsedathm}
%
% Comandes de capsalera.
%
\let\@subsubtitol\@empty
\newif\if@profe \@profefalse
\let\titol\title
\let\data\date
\gdef\@date{\today}
\let\thanks\relax
\def\subtitol#1{\gdef\@thanks{#1}}
\def\subsubtitol#1{\gdef\@subsubtitol{#1}}
\def\introduccio#1{\gdef\@subsubtitol{\paragraph{Introducci\'o:} #1}}
\def\@printtitol#1{\noindent{\Large #1}}
\def\printtitol#1{\par\par\bigskip\par\@printtitol{#1}\par\par\medskip}
\def\@precomandes{}
\def\AtBeginCapsalera#1{\g@addto@macro\@precomandes{#1}}

\newcommand{\professor}[1]{\ifx#1\empty \@profefalse \else
    \if@profe \gdef\@sp{s} \g@addto@macro\@author{ \cr & #1}
    \else \gdef\@sp{} \gdef\@author{#1} \@profetrue
    \fi
  \fi}

\renewcommand{\maketitle}{\newpage\null\begingroup\@precomandes
  \centering{\LARGE\bf \@title}\par\bigskip
  \if@profe\hfill\begin{tabular}{ll} Prof\@sp: & \@author\end{tabular}
  \par \bigskip \fi \@printtitol{\@thanks} \hfill \@date\par\par\endgroup
  \noindent\@subsubtitol\par\par\bigskip\par\par\medskip\par\par\noindent\ignorespaces}
%
% Llistes, Examens i programa; comandes genriques
%
\renewcommand\theenumi{\@arabic\c@enumi}
\renewcommand\theenumii{\@alph\c@enumii}
\renewcommand\theenumiii{\@roman\c@enumiii}
\renewcommand\theenumiv{\@Alph\c@enumiv}
\renewcommand\labelenumi{\theenumi.-}
%
\def\@standard@start{\maketitle\enumerate\iniciacontador}
%
% Sistema de recordar contadors
%
\newcounter{progiexs@enumi}
\newcounter{progiexs@enumii}
\newcounter{progiexs@enumiii}
\newcounter{progiexs@enumiv}
%
\newcommand{\recordacontador}{\setcounter{progiexs@\@enumctr}{\value{\@enumctr}}}
\newcommand{\iniciacontador}[1][\empty]{%
  \ifx#1\empty\setcounter{\@enumctr}{\value{progiexs@\@enumctr}}%
  \else\setcounter{\@enumctr}{#1}\addtocounter{\@enumctr}{-1}\fi%
  \setcounter{progiexs@\@enumctr}{0}%
}
%
% Comandes especifiques
%
\let\llista\@standard@start \let\endllista\endenumerate
\let\examen\@standard@start
\def\endexamen{\endenumerate\ifx\@durada\empty\else\nopagebreak\bigskip
               \begin{center}\fbox{Durada de l'examen: \@durada}\end{center}\fi}
\def\@durada{} \newcommand{\durada}[1]{\gdef\@durada{#1}}
%
% Problema amb cassos encolumnats.
% s:
% \begin{autoalign}[3]
% \alignitem{y'-\frac{y}{x}=x,} .... \alignitem{y'+2\,\frac{y}{x}=x^3,}
% \end{autoalign}
%
\newcount\@modulus@
\def\c@modulus#1#2{\@modulus@=\the#1 \divide\@modulus@ by #2%
   \multiply\@modulus@ by #2 \advance#1 by -\the\@modulus@}
\newcounter{alignitem@count}
\newenvironment{autoalign}[1][2]{\begingroup\def\cols@num{#1}\setcounter{alignitem@count}{0}%
   \csname align*\endcsname}{\endalign\endgroup}
\newcommand{\alignitem}[1]{\addtocounter{alignitem@count}{1}
  \text{(\alph{alignitem@count})} & \quad #1 &
  \begingroup\c@modulus\c@alignitem@count{\cols@num}\relax
    \ifnum\value{alignitem@count}=0 \gdef\@endrow@{\\}\else\gdef\@endrow@{\relax}\fi
    \endgroup\@endrow@}
%
%
% Comandes pels programes
%
\newif\if@apartat \@apartatfalse
\let\programa\@standard@start
\def\font@apartat{\scshape}
\def\font@tema{\large\bfseries}
\def\endprograma{\if@apartat\end{enumerate}\fi\endenumerate}
\newcommand{\tema}[1]{\if@apartat\end{enumerate}\@apartatfalse\fi\par\par
                      \vspace{\parskip}{\font@tema \item #1.}}
\newcommand{\apartat}[1]{\if@apartat\else\@apartattrue\begin{enumerate}[(a)]\fi\item {\font@apartat #1.}}
\newcommand{\contingut}[1]{\begin{quote} #1 \end{quote}}
%
\newcommand{\FontApartat}[1]{\def\font@apartat{#1}}
\newcommand{\FontApartatStandard}{\let\font@apartat\relax}
\newcommand{\FontTema}[1]{\def\font@tema{#1}}
\newcommand{\FontTemaStandard}{\let\font@tema\relax}
%
% Comandes de Sessions
%
\def\@titol@sessio{Sessi\'o}
\newcommand{\titolsessio}[1]{\def\@titol@sessio{#1}}
\newcommand{\sessio}[2][\empty]{\def\dummy{#1}%
   \if@apartat\else\@apartattrue\begin{enumerate}[{{\bf \@titol@sessio}} 1.-]\iniciacontador\fi
   \item {\font@apartat #2\ifx\dummy\empty\else{\normalfont\itshape\ (#1)}\fi:}
}
%
\newcommand{\titollinia}[1]{\strut\newline\noindent{\normalfont\bfseries #1}\ }
\let\plainparagraph\titollinia
%
% Notes i tutories
%
\newcommand{\titolcaixa}[2]{\newdimen\@mida \newbox\@caixa
  \dimen\@mida=\textwidth \advance\dimen\@mida by -\parindent
  \setbox\@caixa=\hbox{\bfseries #1:\ }
  \advance\dimen\@mida by -\wd\@caixa \medskip
  \hbox to\textwidth{\box\@caixa\hfill\parbox[t]{\dimen\@mida}{#2.}}\bigskip}
%
\newcommand{\tutories}[3]{\par\par\titolcaixa{Horari de consultes\ifx#1\empty\else { #1}\fi}{
                                         #2.\\ \texttt{Despatx:} #3}
}
\endinput
